/*
	This software is copyright by Rafael Robayna.
	You may not reproduce or modify this without
	written permission by the origional author.
	Email: rrobayna@gmail.com for suggestions.
*/

	var animationClockStart;
	var animationControlPlay = false;
	var animationControlRecord = false;
	var animation;
	var curAnimationNode;

	function newAnimation() {
		stopAnimation();
		animation = null;
		clearCanvas();
		setActiveTransportButton(0);
		startRecordAnimation();
	}

	function startRecordAnimation() {
		animationControlRecord = true;
		if(animation == null || curAnimationNode == null) {
			clearCanvas();
			animation = new Object();
			curAnimationNode = null;
			animationClockStart = new Date().getTime();
			setDrawAction(5);
		} else {
			animationClockStart = new Date().getTime() + curAnimationNode.time;
			playAnimation();
		}
	}

	function recordAction() {
		var animationNode = getAction();
		addNode(animationNode);
	}

	function getAction() {
		var animationNode = new Object()
		animationNode.startPos = startPos;
		animationNode.curPos = curPos;
		animationNode.action = curDrawAction;
		animationNode.time = getAnimationTime();
		animationNode.color = 'rgba('+color_red+','+color_green+','+color_blue+','+color_alpha+')';
		animationNode.lineWidth = ctx.lineWidth;
		animationNode.next = null;
		return animationNode;
	}

	function addNode(animationNode) {
		if(animation.first == null) {
			animation.first = animationNode;
			animation.last = animationNode;
		} else {
			if(animationNode.time >= animation.last.time) {
				animation.last.next = animationNode;
				animation.last = animationNode;
			} else {
				while(curAnimationNode.next.time <= animationNode.time) {
					curAnimationNode = curAnimationNode.next;
					paintAnimationNode();
				}
				animationNode.next = curAnimationNode.next;
				curAnimationNode.next = animationNode;
			}
		}
		if(animation.first.next == animationNode) {
			animationClockStart = new Date().getTime();
			animation.first.time = 1;
			animationNode.time = 1;
		}
		curAnimationNode = animationNode;
	}

	function getAnimationTime() {
		return new Date().getTime() - animationClockStart;
	}

	function stopAnimation() {
		animationControlPlay = false;
		animationControlRecord = false;
		setActiveTransportButton(2);
	}

	function playAnimation() {
		animationControlPlay = true;

		if(curAnimationNode != null) {
			if(curAnimationNode == animation.last && !animationControlRecord) {
				clearCanvas();
				curAnimationNode = animation.first;
			}
			animationClockStart = new Date().getTime() - curAnimationNode.time;
			getAnimationNode();
		} else {
			animationClockStart = new Date().getTime();
			curAnimationNode = animation.first;
			getAnimationNode();
		}
	}

	function getAnimationNode() {
		if(!animationControlPlay) return;

		if(curAnimationNode != animation.last) {
			while(curAnimationNode != animation.last && curAnimationNode.next.time < getAnimationTime()) {
				curAnimationNode = curAnimationNode.next;
				paintAnimationNode();
			}
			setTransportPosition(animation, getAnimationTime());
			window.setTimeout("getAnimationNode()", 5);
		}	else if(!animationControlRecord) {
			 stopAnimation();
		}
	}

	function paintAnimationNode() {
		ctx.save();
		ctx.fillStyle = curAnimationNode.color;
		ctx.strokeStyle = curAnimationNode.color;
		ctx.lineWidth = curAnimationNode.lineWidth;
		drawActions[curAnimationNode.action](curAnimationNode.startPos, curAnimationNode.curPos, ctx, false);
		ctx.restore();
	}

	function goToAnimationNode(time) {
		stopAnimation();
		if(curAnimationNode.time > time) {
			clearCanvas();
			curAnimationNode = animation.first;
		}

		while(curAnimationNode != null) {
			paintAnimationNode();
			if(curAnimationNode.next == null || curAnimationNode.next.time > time) {
				break;
			} else {
				curAnimationNode = curAnimationNode.next;
			}
		}
	}